01/03/2004 (version 2.30)
----------
1. Portuguese Brazil language, template, htmlarea translation minor update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
2. fix a bug that user preference could not be saved
ps:2.30 is released again because of this bug...
3. Italian language and templates translation minor update
   (thanks to Marvi Benedet, marvi.AT.menhir.biz)
4. fix a bug that template tag @@@DELPOP3STRSTART@@@ was not cleaned in 
   editpop3


01/02/2004
----------
1. new option enable_spellcheck in openwebmail.conf.default
   prefs.template translation update
   (thanks to Tamas R., freddy.AT.lamer.hu for his patch and update)
2. Polish prefs.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)


01/01/2004
----------
1. code clean for datetime routines
2. simplify the user preference for first time login user


12/31/2003
----------
1. fix a bug in copying/moving to a destination folder which set the metainfo
   of a folder before the folder is closed.
2. Spanish language and template files translation minor update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
3. Thai template and htmlarea files translation update
   (thanks to Atsawin Chaowanakritsanakul, joke.AT.nakhon.net)
4. New mirror site at San Diego, CA, US
   http://openwebmail.mirrors.redwire.net
   (thanks to Japheth Cleaver in Redwire Broadband, mirror.AT.redwire.net)


12/27/2003
----------
1. Bulgarian language, template, htmlarea translation minor update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)
2. improve compatibility with bad implemented pop3 server(e:gnu-pop3d) 
   that doesn't support both LAST and UIDL command
   (reported by Jesse, 0947111446.AT.pchome.com.tw)


12/19/2003
----------
1. fix the bug that 'block smtprelay' and 'block email' in readmessage won't work
   (reported by zahari, mrzahz.AT.users.sourceforge.net)
2. fix the bug that all domains always reference the main templates even the 
   domain has defined its down template path
   (reported by zahari, mrzahz.AT.users.sourceforge.net)
3. Polish prefs.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
4. add option webdisk_symlinkout_display to control the display of symlinkout
   dirname or filename
   (suggested by Ken Tan, spider369.AT.users.sourceforge.net)
5. fix a bug in addressbook that invalid regex would cause error
   (thanks for Tamas Reinhardt, freddyke.AT.users.sourceforge.net for his patch)
6. fix a bug that message with empty body won't be correctly indexed if it 
   appears at the end of folder
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
7. Norwegian language and templates translation update
   (thanks to Are Tysland, are.AT.valinor.dolphinics.no)


12/18/2003
----------
1. use open(F, "+<filename");seek(F,0,2); instead of open(F, ">>filename");
   As the later one is unbuffered, which imples a very big impact on file
   write over NFS. In our testing, the time of copying a 15MB file over NFS
   is reduced from 67 sec to 0.7 sec, the speedup is about 95x. :)
 
   So we highly recommend systems running Open WebMail over NFS upgrade to 
   this releae as soon as possible.

2. French language and template files update
   (thanks to Nabil SEFRIOUI, admin.AT.osmium-work.com)
3. Hungarian language file update
   (thanks to Posz Marton, ful_s.AT.fazekas.hu)
4. minor optiomization for users that set default charset to utf-8


12/17/2003
----------
1. fix a bug in webdisk that thumbnail timestamp was not kept the same as 
   original image.
2. fix a bug in folderindex() wich could the status of a message to the next one
   (reported by Raj Agarwal, ragarwal.AT.integ.com)
3. fix a typo error in auth_nis.pl.
   (reported by Vladimir M Costa, vlad.AT.univap.br)


12/16/2003
----------
1. minor optimization to mailfilter module
2. fix a bug that old mesages won't be zapped when user tries
   to save same message into the draft folders.
3. msword document preview support in message read, composing and webdisk


12/15/2003
----------
1. list www.postman.net as the online demo site for openwebmail
   (thanks to Arthur Corliss, admin.AT.postman.net)
2. change global filter rule from X-Mailer: [a-z]+$ to 
   X-Mailer: [a-z]{6,}$ so messages generated by PHP webmail won't be
   filtered
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. fix a bug that the content of message/rfc822 attachment will become 
   "snipped..."
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
4. fix a bug that attachment won't be decoded correctly 
   when user choose to download it.
5. add DHTML popup calendar support to openwebmail-cal.pl
   (thanks to Alex Teslik, ateslik.AT.users.sourceforge.net for his patch)


12/14/2003
----------
1. fix a bug that subject in folder view will become 'N/A'
2. heavy code clean
3. change option default_disablejs      from 'no' to 'yes'
                 default_disableemblink from 'none' to 'cgionly'
   add option default_disableembcode and set it to yes.

ps:These above options are useful in filtering malicious code 
   in html message. Please refer to the following URL for more detail
   http://www.kb.cert.org/vuls/id/707100 and 
   http://www.cert.org/advisories/CA-2000-02.html 
   (reported by James Briggs, james.AT.ActionMessage.com)


12/12/2003
----------
1. fix a javascript bug in mailfilter editing
   (reported by James Briggs, james.AT.ActionMessage.com)
2. fix fast msg end check code so it can work with new indexing routine.
3. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)


12/11/2003
----------
1. code clean and BIG performance improvement!
   The folder indexing speed is about 300% to 1000% faster :)
   The mail filtering speed is about 30% faster

   NOTICE!!!

   The dbm options (dbm_ext, dbmopen_ext and dbmopen_haslock) 
   have been moved from etc/openwebmail.conf to etc/dbm.conf.default
   And you may get value for your etc/dbm.conf by running
   
   perl uty/dbmtest.pl

   The use_doctlock option has been moved from etc/openwebmail.conf
   to filelock.conf.default. You may have your own filelock.conf too.

ps:If you are running openwebmail in persistent mode,
   don't forget to 'touch openwebmail*.pl' after making modification
   to dbm.conf or filelock.conf, so speedycgi knows to reload all the
   scripts, modules and conf files in --init.
 
2. filelock option is moved from etc/openwebmail.conf 
   to etc/filelock.conf and etc/filelock.conf.default
   dbm options are moved from etc/openwebmail.conf 
   to etc/dbm.conf and etc/dbm.conf.default
3. add export addressbook support for pine
   (thanks to Matt Roberts, matt.AT.dworkin.org for his code)
4. sort filterrules in the following order explicitly when doing filtering
   priority (small first)
   action (copy first, then move)
   destination folder (INBOX, regular folders, then mail-trash, DELETE)
   rule type (from, to, subject, header, smtprelay, attfilename, textcontent)
5. fix minor bug in mailfilter which passed parameters in wrong order
6. fix minor bug in mailfilter that text content matching in message body 
   always failed
7. fix a typo error in quota_du.pl
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
8. fix a bug that folderlist cache is always missed
9. fix db initial error in openwebmail-tool.pl --init
   (reported by Dominic Lu, dominic.AT.dominic.idv.tw)
10.document correction for the new dbm.conf and filelock.conf
   

12/04/2003
----------
1. catalan language and template files major update
   (thanks to Jordi Sanfeliu, mikaku.AT.fiwix.org) 
2. rename uty/speedy2suidperl to uty/speedy_suid2suidperl
          uty/suidperl2speedy to uty/suidperl2speedy_suid
   and the suid speedy wrapper is assumed to be /usr/local/bin/speedy_suid
3. log action of listarchive, editfile and uploadfile in webdisk
4. fix to openwebmail-vdomain.pl and vdomain related tools under uty/
   for new dotpath routines.
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
5. rename a webdisk file from basename.ext to basename.0.ext 
   if the uploaded file has the same filename basename.ext


12/02/2003
----------
1. rename etc/auth_xxx.conf to etc/auth_xxx.conf.default
   And each auth module will read etc/auth_xxx.conf first,
   If auth_xxx.conf is not available, then read auth_xxx,conf.default instead
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


12/01/2003
----------
1, fix a bug in openwebmail-abook.pl that email address was not escaped
   when invoking mail composer
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
   

11/30/2003
----------
1. minor change to semantic of 'search by subject' in folder view
   In addition to matching by subject, the search will find all related 
   thread by analyzing messageids in the references field
2. move auth*.conf from auth/ to etc/ so all conf file are within 
   same directory
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
3. new option in user preference to control whether to display 
   mini search icon in folder view


11/29/2003
----------
1. fix a bug that option auto_createrc in openwebmail.conf won't work
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
2. minor change to about.template
3. fix to openwebmail-vdomain.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca)
4. fix a bug that the first attachment in message will be not correctly 
   showed as an embedded image
5. add small search icon in 'to' and 'subject' field in folder view
   (suggested by James Briggs, james.AT.ActionMessage.com)
6. new holiday file ja_JP.Shift_JIS
   (thanks to James Briggs, james.AT.ActionMessage.com)


11/28/2003
----------
1. BIG CHANGE!!! Old openwebmail stored internal files in ~username/mail/ 
   with filename with leading dot (.xxx)
   This release stores internal files in ~username/.openwebmail/ instead.
2. new option homedirdotdirname
   This is the name of directory that contains openwebmail internal files
   The default is .openwebmail
3. new option use_syshomedir_for_dotdir
   If this option is set to 'no', then .openwebmail directory will be put into
   cgi-bin/openwebmail/etc/users/username/ instead of ~username/.openwebmail/

ps:Original internal files in ~username/mail/ will be moved into 
   ~username/.openwebmail/ automatically after user login or 
   openwebmail-tool.pl check.

4. fix a "undefined dateserial2gmtime" bug in openwebmail.pl 
5. fix a bug in mailfilter that regular expression was used as normal text 
   for matching


11/27/2003
----------
1. fix bug related to thumbnail that untaint function was called 
   without specifying the ow::tool:: package name
2. fix a bug that openwebmail-tool.pl called the mailfilter() routine 
   with wrong number of paramters
3. fix the undefined main::get_info_messageids_sorted_by_date bug
   in openwebmail-advsearch.pl 


11/26/2003
----------
1. move auth_xxx.pl into auth/ and quota_xxx.pl into quota/
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
2. move global setting in auth_xxx.pl into auth_xxx.conf
   so no more change to script itself is required for different cases.

Note: If your openwebmail is running in persistent mode,
      you have to execute 'touch openwebmail*pl' in cgi-bin/openwebmail/
      after the auth_xxx.conf is modified, or the it won't be reloaded.

ps: It is highly recommended to remove old openwebmail before installing this
    one, or you will have some stale files in cgi-bin/openwebmail/modules
    All data format are the same, there should be no danger to upgrade. :)


11/25/2003
----------
1. rename filter_badformatfrom t filter_badaddrformat in preference
   It filters messages with email addresses in bad format
2. New mirror site at Nashua, NH, USA
   http://openwebmail.nobandwidth.net 
   (thanks to John Cole, elonex.AT.kirkwor.com)


11/22/2003
----------
1. insert \n for long html lines before passing html to the composer
   or the width of html message composer may not fit within screen resolution
2. fix the bug in uty/iconv.pl.fake that it could not find iconv-chinese.pl 
   and iconv-japan.pl
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. Polish language, prefs.template and htmlarea-lang.js minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
4. mirror site openwebmail.insecure.pl changed its name to 
   openwebmail.ippartners.pl
5. fix "Undefined subroutine &main::encode_base64" error in pop3book.pl


11/20/2003
----------
1. move non folder format related code out from maildb.pl
2. fix a type error in $ENV cleanup that the BASH_ENV was written as BASHENV.
   (reported by Dea, dea.AT.lamp.polito.it)


11/19/2003
----------
1. rearrange the hierarchy of script files
   a. package name for auth module, quota module and language files
      is changed from openwebmail:: to ow::
   b. all module files are moved into cgi-bin/openwebmail/modules
      (module means the script has its own package name like ow:xxx)
   c. all shared files are moved into cgi-bin/openwebmail/shares
   d. split code from maildb.pl/ow-shared.pl into new shared fils or modules

   This new one is much modular than before and should be faster

ps: It is highly recommended to remove old openwebmail before installing this
    new one, or you will have some stale script files in cgi-bin/openwebmail/
    All data format are the same, there should be no danger to upgrade. :)


11/18/2003
----------
1. fix some file permissions under data/
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca)
2. Ukrainian language and template translation minor update
   add UK holiday file
   (thanks to Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)
3. fix minor bug that space char in mimewords was not properly 
   encoded/decoded
   (reported by Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)


11/17/2003
----------
1. rename option savedsuid_support to has_savedsuid_support
   old name is still valid for backward compatibility.
2. fix the insecure $ENV{IFS} problem
   (reported by RJ Ent ,unixabg.AT.users.sourceforge.net)
3. better UI for duplicated mis-spelled words in openwebmail-spell.pl,
   only one dropdown menu will be used for same word correction.
4. add options webdisk_allow_untar, webdisk_allow_unzip, webdisk_allow_unrar
   webdisk_allow_unarj, webdisk_allow_unlzh to openwebmail.conf.default
   (suggested by David Mazieres, sfxxx.AT.users.sourceforge.net)


11/16/2003
----------
1. improve the speed of spellchck by using a mem dic and
   caching check result


11/15/2003
----------
1. fix a bug in openwebmail-vdomain.pl that getgrname won't return gid 
   if it is used as a string parameter
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. check failure of spell personal dictionary open
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. use routine hiddens() instead of the CGI.pm hidden() routine.
   This saves us 580 lines of redundant code :)
4. fix a bug in folder view that the search result won't be properly cached.
5. instead of creating pdic to eliminate startup error msg,
   openwebmail-spell.pl now ignores the error returned by pipeopen()
   if the spellchecker is started up properly
6. Thai language and templates translation minor update
   (thanks to Atsawin Chaowanakritsanakul, joke.AT.nakhon.net)


11/14/2003
----------
1. Indonesian language and template translation update
   (thanks to James Briggs, james.AT.ActionMessage.com)
2. minor fix to openwebmail-spell.pl for less cpu usage
3. fix the bug in openwebmail-spell.pl that words were saved into 
   personal dictionary properly, but the won't be loaded by spellchecker 
   in next check.
ps:the personal dictionary will be set to the spellchecker default now
   (.ispell_words for ispell, .aspell.english.pws for aspell)
4. minor change to openwebmail-tool.pl to remove duplicated code
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


11/13/2003
----------
1. rewrite pipe code of openwebmail-spell.pl to make it more error friendly.
2. fix a bug in new pipecode that word correction menu may appear in wrong
   place on slow machine.
3. change personal dictionary to ~/mail/.ow.$spellcheckname.$dictionaryname
   so the personal dict in openwebmail won't be shared with other application.
4. change param('xxx') to param('xxx')||'' in variable assignment
   or passing multiple parameters may fail because of null value
5. fix a javascript bug in openwebmail-send.pl which prevented the
   'auto-saving composed message to draft folder' from working


11/12/2003
----------
1. fix a bug that block tags options in openwebmail.conf won't accept 
   null values
   (reported by Florian Effenberger, florian.AT.effenberger.org)


11/11/2003
----------
1. clean code related to update_virtusertable() and 
   rename it to update_virtuserdb()
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)
2. optional phone input table display in composemessage for big5 charset users


11/10/2003 (version 2.21)
----------
1. put 2.21 as a major bug fixed release
   for "Insecure dependence" error on some platform with new perl 5.8.x
   The error is fixed by using untaint() routine instead of direct untainting


11/09/2003
----------
1. play sound "you have new mail" only once for new messages
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. put more options into none_item processing
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


11/08/2003
----------
1. fix a bug in new readocnf code that language andy logindomain
   wouldn't change once a user have loginned in
2. fix a bug that vusers define in option localusers list won't be counted
   in openwebmail-tool.pl -a
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. fix the bug that some options with auto value were not properly initialized
4. minor speedup by caching all conf file in memory
5. holiday file en_GB for British update
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)


11/07/2003
----------
1. minor speedup with great improved readconf() routine and openwebamil-tool.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his great work)
2. use a new routine untaint() to untaint most variables.
   Perl behaves strangely sometimes if we use regex to untaint variable
   directly too many times. And use of this routine fixes the problem.
3. new debug routine refdump()
4. fix a bug that comma would be striped out from email address in
   addressbook editing, which prevented the user to input group mail address.
   (reported by Marcel Weber)
5. use $SIG{'CHLD'}='IGNORE' instead of $SIG{'CHLD'}=sub { wait; };
   so persistent process keeps alive after the child process terminates.
   This should speedup the readmessage quit a lot on slow machines.


11/06/2003
----------
1. new auth module: auth_nis.pl
  (thanks to Vladimir M Costa, vmcosta.AT.spamcop.net for his code)


11/05/2003
----------
1. turn page textfield in message list into dropdown menu
2. openwebmail-tool.pl -a now tries to scan all users under all domains
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


11/04/2003
----------
1. better page control in folder view
2. add gotop icon in both folder view and readmessage
   (suggested James Briggs, james.AT.ActionMessage.com)
3. fix a bug that option enable_loadfrombook, enable_editfrombook didn't work
   (reported by Mike Harness, mharness.AT.users.sourceforge.net)


11/02/2003
----------
1. always show charset drop-down menu in readmessage()
   (suggested by Vicente Chua, chuavv.AT.mail.savs.hcc.edu.tw)
2. new iconset: Cool3D.Korean
   (thanks to Youngho Kang, ykang.AT.deskweb.net)


11/01/2003
----------
1. Indonesian language and template translation update
   (thanks to James Briggs, james.AT.ActionMessage.com)
2. improved html2text() in htmltext.pl


10/31/2003
----------
1. change background color for foldernames in dropdown menu in folder view
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
2. set the font color of calendar reminder with style sheet instead of
   hard coded value
   (suggested by Ham MI-IH, Torsten Brumm, torsten.brumm.AT.kuehne-nagel.com)
3. improved html2text() in htmltext.pl


10/29/2003
----------
1. fix a bug in openwebmail.pl that caused a forever loop page redirection
   between openwebmail.pl and start_url
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
2. change the color for folders in dropdown menu in folder view
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


10/27/2003
----------
1. fix a bug in is_dst() in ow-shared.pl that caused the daylight-saving time
   auto switch error. The month returned by gmtime() is 0..11, not 1..12.
   (reported by James Briggs, james.AT.ActionMessage.com,
                 Martin Gignac, lmcgign.AT.mpbn.ericsson.ca)
2. fix a bug in openwebmail-abook.pl that & char will be stripe out from
   email address when adding new entry to addressbook
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)
3. add option mailsentwindowtime option to user preference to control
   the use of mail sent notification window.


10/26/2003
----------
1. fix a bug in ow-share.pl which prevented the options
   enable_loadfrom, enable_editfrom, frombook_for_realname_only from working
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


10/24/2003
----------
1. support ps2pdf, pdf2ps in webdisk
2. better display of search result in webdisk


10/23/2003
----------
1. change options in openwebmail.conf.default
   remove: enable_setfrom, enable_setfromemail
   add:    enable_loadfrombook, enable_editfrombook, frombook_for_realname_only
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


10/22/2003
----------
1. New mirror site at Florida, USA
   http://unixnetworks.org/openwebmail/
   (thanks to Jonny Elonex, elonex.AT.kirkwor.com)
2. fix a bug in delete_vuser() in openwebmail-vdomain.pl
   (thanks to Antonio Godinho, godinho.AT.itcom.co.mz for his fix)
3. change permission of the directory
   cgi-bin/openwebmail/etc/users/
   cgi-bin/openwebmail/etc/sessions/
   from 770 to 771.
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)
4. fix the bug that "move to trash" button shows "over quota"
   instead of deleting message when user is over quota.
   (reported by Mike Fahey, mfahey.AT.enter.net)
5. handle mime words in a plain text message
ps:This happens if a mail client that doesn't know MIME tries to
   forward/reply/include a message sent from a MIME compliant client


10/20/2003
----------
1. use boldtext for folders with new messages and
   use grey text for folders without newmessages
   in folder select dropdown menu


10/18/2003
----------
1. fix a minor bug in el/login.template
   (reported by Dieter Schicker, dilino.AT.users.sourceforge.net)


10/17/2003
----------
1. add 'smartfilter_bypass_goodmessage' option to openwebmail.conf.default


10/15/2003
----------
1. minor optimization to is_dst() routine
   show user timeoffset in title bar
2. add shortcut key help in HtmlArea editor


10/14/2003 (version 2.20)
----------
1. fix a minor bug in openwebmail-tool.pl that unexisting routine
   dbm_close() is called, it should be close_dbm().
2. fix a bug in routine gettimeoffset() that always returns 0
   when is_dst() is false


10/12/2003
----------
1. fix two day-light-saving time bugs in dst auto mode
   a. messages sent from other mail client to openwebmail would have
      an arrival time one hour early than the real one.
   b. messages sent from openwebmail would have a wrong date field
      one hour late than the real sending time
2. cache style files in memory for faster response


10/11/2003
----------
1. recreate b2g, g2b and lunar db in openwebmail-tool.pl --init
   in case the existing db could not be recognized.
2. fix the problem that when reading message with lots of pictures
   attachments, few of them may be displayed as broken graph ("X").
   (thanks to Dominic Lu, dominiclu.AT.users.sourceforge.net
    who reported this problem and provided his machine for testing)
3. pass filenames to /use/bin/file though listfile to avoid dangerous
   shell escape chars


10/10/2003
----------
1. fix a small bug in userstat.pl
   (thanks to Luis Fernando Manesco, lmanesco.AT.cena.usp.br for his fix)
2. reply html message as text if replyformat==auto and the html message is
   showed as text
3. rewrite open_dbm() in a conservative way for better dbm compatibility


10/08/2003
----------
1. fix a bug in open_dbm() which caused an error when trying to read
   an unexist dbm
   (reported by robmorin.AT.users.sourceforge.net)
2. a small cgi userstat.pl has been added.
   Static html pages can display user mail/calendar status dynamically
   by including this cgi as javascript.
   Please refer to readme.txt for more detail


10/07/2003
----------
1. enable html editor for Firebird 0.6.1 or above
2. fix a bug in openwebmail_clearall()
   which tried to reset ruid back to 0 at end of each request.
   This is not required, only euid to 0 is enough
   (reported by James Briggs, james.AT.ActionMessage.com)


10/05/2003
----------
1. fix "Couldn't update index db" bug for linux with
   GNU dbm 1.x or ndbm (.pag)
   (thanks to Dominic Lu, dominiclu.AT.users.sourceforge.net
    who reported this problem and provided his machine for testing)


10/03/2003
----------
1. New mirror site at Austria
   http://openwebmail.typoheads.com
   (thanks to Typoheads.Com, openwebmail.AT.typoheads.com)


10/02/2003
----------
1. fix the "Couldn't update index db" problem
2. fix the ".vacation dbm could not be read" problem
3. fix the ".filter.book.db and .uidl.pop3.site.db couldn't be read" problem

ps: All the above problems would happen when the default dbm format used
    in perl has been changed, which is always introduced by the upgrade of
    system or perl related package
    (thanks to Chip Lee, chip.AT.turtle.ee.ncku.edu.tw
     for his help in solving this problem)

4. The -i and -iv options in openwebmail-tool.pl will reindex a folder
   if the format of index db could not be recognized.
   So sysadms could use /path/openwebmail-tool.pl -i -a to fix db index
   for all users
5. the undo/redo in htmlarea editor works under IE6 now
   by turning off the htmlarea status bar
   (solution from htmlarea forum :))


09/30/2003
----------
1. do more check on password type in auth_mysql.pl, auth_pg.pl
   and auth_pgsql.pl
   (suggested by Sergio Rua, srua.AT.debian.org)
2. add return-path email to cc: field in replyall mode
   This could be useful in replying messages from mailinglist
   (suggested by Scott A. Mazur, scott.AT.littlefish.ca)


09/29/2003
----------
1. Portuguese Brazil language, template, htmlarea translation update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
2. fix the "Insecure dependency at ow-shared.pl line 1119..." problem
   when calling editprefs() in openwebmail-prefs.pl
ps:The problem is fixed by simplely using different syntax,
   there seems buffer overflow somewhere in new perl 5.8.0 or speedycgi?
   Tricky!
3. add symlink support in webdisk


09/27/2003
----------
1. Hebrew(he.CP1255) language and templates translation
   (thanks to Yehuda Drori, yehuda.AT.whatsup.org.il,
              Shay Sevet,shay.AT.sevet.com)
2. new iconset: Cool3D.Hebrew
   (thanks to Yehuda Drori, yehuda.AT.whatsup.org.il)


09/26/2003
----------
1. New mirror site at Hamburg, Germany
   http://www.openwebmail.de
   (thanks to Torsten Brumm, torsten.brumm.AT.kuehne-nagel.com)
2. minor adjustment of buttons in webdisk


09/23/2003
----------
1. French htmlarea files translation  update
   (thanks to Frederic GLISE, fred.AT.forceinfo.net)


09/18/2003
----------
1. fix a bug in calendar update that caused error like below
   "Month '-1' out of range 0..11 at /dev/fd/3 line 2474"
   (reported by Martin Gignac, lmcgign.AT.mpbn.ericsson.ca)
2. Dutch language, templates and htmlarea files translation update
   Dutch help tutorial translation
   (thanks to Jeroen Visser & Robert den Ouden, openwebmail.AT.forty-two.nl)
3. Bulgarian language, template, htmlarea translation update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)


09/17/2003
----------
1. add install-owm-suse.sh to cgi-bin/openwebmail/uty/
   (thanks to Ham MI-IH, Torsten Brumm, torsten.brumm.AT.kuehne-nagel.com)
2. add zh_HK.Big5 holiday file
   (thanks to faifai.AT.users.sourceforge.net)
3. Polish htmlarea files translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
4. Italian language and templates translation update
   (thanks to Marvi Benedet, marvi.AT.menhir.biz)


09/16/2003
----------
1. Polish language translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
2. Slovak prefs.template, logout.template and holiday file update
   (thanks to Peter Sedivy, root.AT.us.svf.stuba.sk)
3. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
4. Serbian language and template files translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
5. fix a minor bug in htmlarea.js that set the wrong URL for blank.html
   in html editor initialization
6. fix a bug that user can't logout if webmail is disabled
   (reported by Edwin Lee, edwinlee2000.AT.users.soureforge.net)


09/13/2003
----------
1. Deutsch language, templates and htmlarea files translation update
   (thanks to Markus Zander, zander.AT.datacontrol-online.de)
2. add SuSE-README.txt to data/openwebmail/doc/
   (thanks to Torsten Brumm, tob.AT.brummi.dyn.ee)
3. Slovak language, templates translation update
   (thanks to lubos klokner, lubos.AT.klokner.sk)


09/12/2003
----------
1. display the "Message ... has been sent" for confirmation
   when mesage has been sent successfully


09/11/2003
----------
1. upgrade the html composer from htmlarea 3.0 alpha to 3.0 beta
   The respose speed is greatly improved.
ps:The redo/undo function in this 3.0 beta doesn't work under IE.
   We will fix it ASAP when the interactive.com releases the patch.


09/08/2003
----------
1. Polish language, templates translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
2. fix a bug in mailfilter.pl that exclusion comparison always matches
   in case the expression contains special regex chars
   So user can uses filter rule like below to filter mails not for
   his email addresses :)

   10, To, exclude, email1|email2|email3, move, mail-trash


09/04/2003
----------
1. fix the safegmtime() Day 31 bug in ow-shared.pl
   (reported by Oswald Luck, luckio.AT.userssourceforge.net
                Abraham Hung, abrahamhung.AT.userssourceforge.net
                Corey Hauer, coreyhauer.AT.userssourceforge.net)


09/02/2003
----------
1. rewrite calendar item add/edit routines
   All properties of a existing calendar item could be edited now
   (thanks to Alex Teslik, ateslik.AT.users.sourceforge.net for his patch)
2. fix a bug that spellcheck can not work with aspell if personal dictionary
is used
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


08/26/2003
----------
1. add new option 'show html message as text' to user preference
   This is very useful in defending against the HTML virus/spamming mail.
   (suggested by Thomas Chung, tchung.AT.openwebmail.org)
2. fix a bug in html2text which ate non-tag data sometimes
3. fix the safetimegm() that the eval could not capture the exception of
   timegm() routine.
4. fix a bug in openwebmail*.pl that the $SCRIPT_DIR  may be set to
   wrong value if the string '.pl' appears in the middle of script path
   (reported by Pawel Foremski, pavcio.AT.4lo.bytom.pl)


08/25/2003
----------
1. add option enable_webmail to openwbemail.conf.default
   This option will disable webmail related stuff in the whole package
   (suggested by Kevin, kevin.AT.bluelavalamp.net)
2. add option enable_userfilter to openwebmail.conf.default
   This option will disallow users to write their own mail filters
3. add option enable_preference to openwebmail.conf.default
   This option will disable preference setup menu from user
4. fix the bug that some checkbox options can not be cleared in preference
   (reported by Dominic Lu, dominiclu.AT.users.sourceforge.net)


08/24/2003
----------
1. add option autopop3wait to user preference to control
   how long openwebmail should wait before putting pop3 fetch process
   into background
2. Deutsch language, prefs.template, de holiday file update
   add de_CH holiday file
   (thanks to Marco Steinacher, msteinacher.AT.websource.ch)
3. disable a web control if it is set with DEFAULT_ directive in
   openwebmail.conf
   (suggested by Florian Effenberger, florian.AT.effenberger.org)
4. fix a bug in openwebmail-vdomain.pl that $vhomedir in delete_vuser()
   should be untainted
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


08/23/2003
----------
1. Deutsch language file update
   (thanks to Markus Zander, zander.AT.datacontrol-online.de)


07/31/2003
----------
1. fix a bug in openwebmail-prefs.pl that enable_setfrom was mis-typed
   as enable_editfrom
   (thanks to Chris Heegard, heegard.AT.nativei.com for his fix)
2. listarchive and extraction support for ms tnef file in webdisk


07/29/2003
----------
1. Deutsch language file update
   (thanks to Markus Zander, zander.AT.datacontrol-online.de)


07/20/2003
----------
1. fix the smiley face bug again in openwebmail-read.pl
   (reported by Matt Roberts, matt.AT.dworkin.org)


07/19/2003
----------
1. fix the smiley face bug in openwebmail-read.pl
   (reported by Matt Roberts, matt.AT.dworkin.org)


07/18/2003
----------
1. fix an "Insecurity dependence" bug in openwebmail-vdomain.pl
   (reported by Jarrod Hardy, matrix-sx.AT.users.sourceforge.net )


07/17/2003
----------
1. fix to openwebmail-spell.pl so personal dict gets updates when user
   clicks 'finish checking'
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. fix a bug in maildb.pl which caused lock error in moving message
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. Spanish language, templates translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
4. Italian holiday file
   (thanks to Davide Sacchetti, davide.sacchetti.AT.arpal.org)
5. Polish language, templates translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
6. fix bugs in auth_ldap.pl that made change_userpassword() always fail
   (thanks to Ignacio Lagomarsino, ilagomarsino.AT.preu.edu.uy)
7. support multiple postfix alias/virtual files
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)


07/12/2003
----------
1. enhanced virtual/local user mixture handling in openwebmail-vdomain.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)


07/10/2003
----------
1. refined dbm lock code
   the dbmtest.pl now reports proper values on most platforms
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)


07/08/2003
----------
1. fix a bug in spellcheck that personal dict could be properly updated
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


07/04/2003
----------
1. fix a bug in openwebmail-vdomain.pl that vuser in delete_vuser should be
   untainted
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. Romanian language and templates translation major update
   (thanks to Zeno Popovici, zeno.popovici.AT.ulbsibiu.ro)
3. disable web cache of message content to avoid the message number inconsistence
   after message removal
   (reported by Martin Gignac, lmcgign.AT.mobilitylab.net)


07/02/2003
----------
1. fix a bug in ow-share.pl that wrong parameter could be passed to timegm
   without check
   (reported by Ron E., ree.AT.thunderstar.net)


07/01/2003
----------
1. fix a bug that calendar event with same starttime and endtime won't be
   displayed in dayview
   (reported by Ignacio Lagomarsino, ilagomarsino.AT.preu.edu.uy)


06/30/2003
----------
1. add zh-hk and zh-sg to %httpaccept2language
   (thanks to Paul T.C.Fung, paulfung.AT.users.sourceforge.net)


06/29/2003
----------
1. Serbian htmlarea files translation
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
2. lot of improvements to openwebmail-vdomain.pl
   a. support suspend login
   b. add/del from.book entries for vuser
   c. multiple view of vuser list
   d. fix a bug that homedir of vuser could not be found
      if option use_syshomedir is set to no
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)


06/26/2003
----------
1. fix a bug that the charset in html body will be wrong
   when sendcharset is not set to "the same as composecharset" in preference
   (reported by INYAKU Tomoya, tomo.AT.jca.apc.org)


06/25/2003
----------
1. Dutch htmlarea files translation update
   (thanks to Jeroen Visser, openwebmail.AT.forty-two.nl)
2. Dutch holiday file
   (thanks to Gertjan Koetsier, gertjan.koetsier.AT.networksforyou.com)
3. fix a bug that lang/ja_JP.eucJP was set with wring package name
   fix a bug in iconv.pl that an additional "\n" will be added to the end
   of converted string
   (reported by INYAKU Tomoya, tomo.AT.jca.apc.org)


06/24/2003
----------
1. Polish language, template and htmlarea files translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
2. Koeran language translation update and a bug fixed
   new iconset: Text.Korean
   (thanks to Thomas Chung, tchung.AT.openwebmail.org)
3. Traditional chinese help tutorial update
   (thanks to Alex Huang, admin.AT.laiwell.com.tw)
4. Dutch language and template translation update
   (thanks to Jeroen Visser, openwebmail.AT.forty-two.nl)
5. Serbian language and templates translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)


06/20/2003
----------
1. Hungarian language file translation update
   (thanks to Posz Marton, ful_s.AT.fazekas.hu)
2. Polish language, template and htmlarea files translation update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
3. fix a bug that operator 'or' should be used instead of operator '||'
   in several places because of the lower precedence of 'or'
   (reported by Massimo Gravino, sfgmax.AT.users.sourceforge.net)
4. fix a bug that HTML presentation for special characters (<, >, &, " ...)
   would be displayed as mis-spelled words in spelling check.
   (reported by Moke Tsing - AMC, moke.AT.amcpl.net)
5. fix a bug that timeout warning doesn't work because @@@PREFSURL@@@
   and @@@SESSIONID@@@ were not expandedcorrectly
   (thanks to Carlos Pina Soares, cps.AT.fcsh.unl.pt for his fix)
6. add data/openwebmail/sound/YouGotMail.Spanish_Male.wav
   (thanks to Eduardo Percossi, Eduardo.AT.Argentina.com)


06/19/2003
----------
1. Portuguese htmlarea files translation
   (thanks to Jose Ferradeira, jferra.AT.sfconsultores.pt)
2. add "bad format from" filter to mailfilter.pl


06/18/2003
----------
1. Portuguese language, template and holiday files update
   (thanks to Jose Ferradeira, jferra.AT.sfconsultores.pt)
2. add routine timeofday_init to gettimeofday.pl for profadd.pl and profdel.pl
   in uty/
3. add default calendar view option in user preference


06/17/2003 (version 2.10)
----------
1. fix a bug that vuser gid may go wrong if it is larger than 9.
   mailgid is used by default for vuser directories in openwebmail-vdomain.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. fix a bug that "devided by zero" may happen in openwebmail-tool.pl
   if folder toal size is 0
   (reported by Carlos Chavez, carlos_chavez_p.AT.users.sourceforge.net)


06/15/2003
----------
1. fix a bug introduced by the patch1 in 06/12/2003 which split gid
   larger than 10 into digits
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
2. fix a bug that repeated background doesn't work in copyright page.
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
3. Argentina holiday file
   (thanks to Eduardo Percossi, Eduardo.AT.Argentina.com)


06/13/2003
----------
1. fix a bug that cal-delete.gif was missing in XP.* iconsets
2. add two utys related to virtual domain user
   uty/virtualsetup.pl - creates the virtual site conf for the local domain
                         and updates the localusers parameter of the main
                         config file.
   uty/virtualconvert.pl - converts real users into virtual users
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)
3. fix a bug that <> was not put around the content-id value in
   attachment header
   (reported by Eduardo Daniel, naty22.AT.users.sourceforge.net)
4. use content-type "multipart/related" for inlined attachments in HTML
   message composing


06/12/2003
----------
1. return all gids of a user in auth module and set them into runtime egid,
   so user can access files based on the gids other than primary gid
   This is quite useful in webdisk.
   (suggested by Jim Allen, jimallen.AT.users.sourceforge.net)
2. insert blank lines before signature in reply and replyall
   (suggested by Martin Gignac, lmcgign.AT.mobilitylab.net)


06/11/2003
----------
1. put "Courier 10 Pitch" into fixed font for message display
   (suggested by Mike Vanecek, open_form.AT.users.sourceforge.net)
2. remove N and  U flag from message ststus if R or O flag exists
3. do not remove javascript or embedded links from a message
   when it is forwarded as original


06/09/2003
----------
1. support disable embedded links/CGIs in user preference
   (suggested by Mike Vanecek, open_form.AT.users.sourceforge.net)


06/08/2003
----------
1. fix a bug that cal-link.gif was missing in XP.* iconsets
   (reported by tadghe.AT.badcode.org)
2. fix a bug that auto selection of holiday file won't work


06/07/2003
----------
1. preliminary support for stationary or signature with HTML tags


06/06/2003
----------
1. more complete check for invalid path access in webdisk
2. minor speedup in login process with javascript window.location.href=...
3. fix a bug in openwebmail-prefs.pl that vuser keeplocalcopy was always on
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


06/05/2003
----------
1. fix a bug that vuser homedir is used before it is created
   clean and improve .forward and .vacation related routines
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca)
2. fix a bug that 'add attachment from webdisk' won't work on mozilla if
   the user has clicked the 'single page' or 'show hidden file' checkbox.
3. little improvement to routines used at request begin and request end
4. fix a bug in auth_unix_colbat.pl that get_userinfo() always returns -2
   (reported by Eduardo Daniel, naty22.AT.users.sourceforge.net)


06/04/2003
----------
1. change content type multipart/related back to multipart/fixed
   to fix incompatibility issue with some mail clients
   (reported by Luis Fernando Manesco, lmanesco.AT.users.sourceforge.net
    fixed by Andreas Jud, a.jud.AT.webflash.ch, thanks!)


06/03/2003
----------
1. Slovak language, templates and HTMLArea file translation update
   (thanks to lubos klokner, lubos.AT.klokner.sk)
2. add --debug option to openwebmail-tool.pl for easier debugging
3. fix a bug that is_localuser check was missed in ow-shared.pl
   and openwebmail-tool.pl
   (reported by Scott A. Mazur, scott.AT.littlefish.ca)


06/02/2003
----------
1. add option localusers to openwebmail.conf.
   This option allows sysadm to mix virtual and real users under same domain
   (thanks to Scott Mazur, scott.AT.littlefish.ca for his great code)
2. fix a bug in auth_vdomain.pl that vdomain directory will be created
   even it is invalid
   fix a bug in ow-shared.pl that session info will be always retrieved
   from auth source even session info cache is already available
   (reported by Scott Mazur, scott.AT.littlefish.ca)
3. a. remove hard-coded fontsize so layout is fully controlled by style sheet
   b. add 8pt to fontsize dropdown menu in user preference
   c. set the width of signature/autoreply/stationery with the same value of
      message composing area
   (suggested by Asar Khan, asarkhan.AT.users.sourceforge.net)


05/31/2003
----------
1. British holiday file update
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)


05/30/2003
----------
1. a smaller preload.pl :)
2. fix a bug in openwebmail-send.pl which caused error if sysadm has set
   mailfooter for his openwebmail system
   (reported by Tate Chen, tatechen)
3. fix minor problem in some templates and HTMLArea editor for RTL language
4. add uty/fixvuser.pl
   This script searches through the postfix aliases and virtual files and
   updates them according to the new virtual user aliases scheme
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his great code)


05/29/2003
----------
1. holiday file en_GB for British
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)
2. add option 'holiday definition' to user preference so user
   can choose which holiday file to use
3. support DEFAULT_ syntax in openwebmail.conf, which can be used to
   set some default that won't be overridden by the user preference.


05/28/2003
----------
1. allow to fetch mail from pop3 server on port other than 110
2. pop3 passwd stored in ~/.pop3.book is encoded with base64
   instead of plaintext


05/27/2003
----------
1. Ukrainian htmlarea files translation update
   (thanks to Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)
2. German Holiday file
   (thanks to Grund Helmut RZ, Helmut.Grund.AT.fh-furtwangen.de)


05/26/2003
----------
1. fix the compatibility problem of InsertSound button in HTML composing
   under Mozilla
2. Portuguese Brazil language, template, htmlarea translation update
   and newmail sound YouGotMail.Brazilian.wav
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
3. Thai language and templates translation update
   (thanks to Atsawin Chaowanakritsanakul, joke.AT.nakhon.net)
4. minor fix for file icon identification in webdisk


05/25/2003
----------
1. fix a bug that some mails on pop3 server may not be retrieved
   if pop3 server supports UIDL and the 'del remot email' was set to off
   (reported by Ron E., ree.AT.thunderstar.net)
2. Spanish language, template, htmlarea translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
3. Bulgarian language, template, htmlarea translation update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)
4. Ukrainian language and template files translation update
   (thanks to Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)
5. Urdu holiday file
   (thanks to Muhammad Umair Abbasi, umair.AT.khi.wol.net.pk)
6. Italian language and templates translation update
   (thanks to Marvi Benedet, marvi.AT.menhir.biz)


05/24/2003
----------
1. support insertion of inlined sound attachment in HTML composing :)
2. fix a bug that url of attachments in href won't be correctly converted
   back to its cid in openwebmail-send.pl
3. only show files of related content-type in insert_image and insert_sound
4. fix a bug that newly input content would lost in HTML composing
   when user clicked 'delete' to delete an attachment
5. show day distance from today in dayview


05/23/2003
----------
1. merge some latest change of HTMLArea from it CVS


05/22/2003
----------
1. eliminate the SSL security alert for HTML editor
   (thanks to psychobabble at http://www.interactivetools.com/iforum/
    Open_Source_C3/htmlArea_v3.0_-_Alpha_Release_F14/https_secure_issue_P8250/)
2. Spanish translation update for HTML editor files
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
3. fix ht bug that attachment list won't appear in InsertImage when
   used with Mozilla
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


05/21/2003
----------
1. fix a bug that word doc attached from webdisk will have content-type
   text/plain
   (reported by alexe-com, alexe.AT.users.sourceforge.net)
2. add more language related stuff to htmlarea-lang.js for better
   i18n support for HTMLArea editor
3. add charset directive to the HTMLArea related html files


05/20/2003
----------
1. rearrange file tree of HTMLArea to get better language translation
2. add the dropdown menu of current attachments to
   popup window of 'Insert Image' button in HTML composing
   This eases the process to put inline image attachment into HTML
3. Portuguese Brazil help tutorial translation update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
4. fix the preview problem in insert image
5. fix a bug that content-id will be removed if the mime obj is not referenced
   by the first html part in message
6. better reformatting message body in replying HTML message
7. fix a bug that HTML edit area will become quite small


05/19/2003
----------
1. remove reference to inline attachment when replying a HTML message
2. Spanish language and templates translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
3. fix a bug that attachment won't be inline properly if there are
   more than on attachments when generating HTML message


05/17/2003
----------
1. heavily rewrite of openwebmail-vdomain.pl module
   to support forward and autoreply on vdomain users
   (thanks to Scott Mazur, scott.AT.littlefish.ca for his great code)
2. extend timeout limit in openwebmail-send.pl to avoid smtp error
   timeout=120 if only one recipient for quicker response.
   timeout=180 for more than one recipients
3. fix a typo error that disabled the editfrom button in preference
   add default_msgformat to openwebmail.conf.default
   (reported by SuperLight, superlight.AT.superlightdns.twbbs.org)
4. better formatting for reply in HTML mode
5. INLINE attachment support in HTML message composing!!!
   The MIME support in Open WebMail is almost completely now :)
6. eliminate content-id for attachment if it is not referenced
7. fix a bug that link copied from attachment table won't be properly
   reverted back to cid when generating html messages
8. set default msgformat to auto in openwebmail.conf.default
   The msg format would be auto selected based on the original message.


05/16/2003
----------
1. HTML Message Composing support!!!
   It is based on the WYSIWYG HTMLArea3.0 editor at
   http://www.interactivetools.com/products/htmlarea/
2. add option enable_setfrom to openwebmail.conf.default. This option controls
   whether user is allowed to set their realname or address in emails.
   (suggested by Kaushik Bhattacharyya, kbhatta.AT.users.sourceforge.net)


05/13/2003
----------
1. fix a minor error in filelock that some debug info would be dump to stdout
   if filelock failed in dotlock mode


05/12/2003
----------
1. allow web cache to be used for request of readmessage and viewatt
   ps: request is based on URL and messageid in URL is unique,
       so cache entries won't have collide with others
2. allow web cache to be used for request of calyear and callist
   by putting calbook timestamp in URL

ps: Since no matter what cache directive(eg: no-cache, no-store, private)
    is put in http header, IE always stores the result to web cache in disk,
    so allowing use of those cache won't hurt the security further.
    And if you worries about caches on proxy servers, SSL should be used.


05/08/2003
----------
1. fix a bug that session won't timeout even timout warning window
   has appeared for more than 60 seconds.
   (reported by Todd Whipple, whip812.AT.users.sourceforge.net)
2. Hungarian holidays file
   (thanks to Tamas Gervai, crown.AT.tolna.net)


05/07/2003
----------
1. replace the year field in web calendar with dropdown date selection menu
2. speedup the javascript routine showmsg() by including the source at
   server side instead of client side.


05/06/2003
----------
1. add Courier and monospace to fixfont list for readmessage
   (suggested by Mike Vanecek, open_form.AT.users.sourceforge.net)
2. add option 'error_with_debuginfo' to openwebmail.conf
   It would put detailed debug info into the openwebmailerror() message


05/05/2003
----------
1. support http compression in attachment download and in file
   download/preview of webdisk
2. fix a bug that option trashreservedday won't work
   (reported by Fernando Monteiro, fcmonteiro.AT.users.sourceforge.net)


05/04/2003
----------
1. minor improvement to routine httpprint()
2. fix a bug that change_userpassword() in auth_pam*pl always failed.
   (reported by Dugal James P., jpd.AT.louisiana.edu)


05/03/2003
----------
1. support http compression
   This is a very useful feature for users with slow connection to the
   openwebmail server, eg: dialup user, PDA user.
2. fix to openwebmail-tool.pl to detect the new DB_Flile 1.806 on RedHat 9.0
   (thanks to Dugal James P., jpd.AT.louisiana.edu for his fix)
3. display persistence, http compression flag at top of window border
   + for persistence mode, z for http compression
4. disable the http compression checkbox at login screen
   if client doesn't support gzip encoding or zlib is not available


05/02/2003
----------
1. fix a bug that abook_defaultfilter was mistakenly written as
   abook_usedefaultfilter in ow-share.pl, openwebmail.conf.default and
   openwebmail.conf.help
   (reported by Hubertus A. Haniel, hubba.AT.unixcook.com)
2. don't put user email in the $to or $cc in replyall mode
   (suggested by Hubertus A. Haniel, hubba.AT.unixcook.com)
3. minor change to preload.pl for command mode.
   You have to specify --all or the script names to preload explicitly
4. split httpheader() from htmlheader()


04/30/2003
----------
1. fix a bug in openwebmail.pl that
   change of delpop3mail_by_default would have no effect on existing users,
   so OWM using auth_pop3.pl would always delete mails on pop3 auth server
   (reported by Chris Chayka, chayka.AT.users.sourceforge.net,
                Ricardo J. Michell, rmichell.AT.users.sourceforge.net,
                gill shamir, gshamir.AT.users.sourceforge.net)
2. fix a bug that option webdisk_allow_symlinkout didn't work
   fix a bug that 'mark folder as read' won't work if use_dotlock was set to yes
   (reported by Hubertus A. Haniel, hubba.AT.unixcook.com)
3. sort the emails in dropdown menu of prefs and composemessage
   with the same order of names in option 'domainnames'
   (suggested by Hubertus A. Haniel, hubba.AT.unixcook.com)
4. fix a minor bug in openwebmail-webdisk.pl that close() was used instead of
   closedir() for dir handle


04/29/2003
----------
1. fix a bug in calendar that the holiday and group events were loaded
   at the same index base number
2. fix the buggy closeall() code at filelock.pl which caused the
   'Attempt to free unreferenced scalar ... line 221.' error at perl 5.8.
   The bug was introduced by patch 1 at 04/27/2003
3. add the cgi-bin/openwebmail/etc/holidays/zh_TW.Big5 an zh_CN.GB2312


04/28/2003
----------
1. minor fix to openwebmail.pl so the option allowed_serverdomain can
   be specified in user conf
   This can be used to limit the loginname for an account in case it
   have many access paths
2. add option enable_strictvirtuser to openwebmail.conf.default
   When an account is mapped by a virtuser in virtusertable,
   set this option to yes if you want to allow only virtuser name for login


04/27/2003
----------
1. close all files in filelock.pl opentable at end of each request
   This fixes the 'Too many open files' and some file lock errors
   when OWM is running in persistent mode.


04/25/2003 (version 2.01)
----------
1. Norwegian language and templates translation update
   (thanks to Are Tysland, are.AT.valinor.dolphinics.no)
2. Japanese (ShiftJIS) language and templates translation update
   (thanks to Captain James and Interactive Artists, LLC,
james.AT.ActionMessage.com)
3. auto adjust the background image url in case openwebmail has been
   reinstalled in different location
   (suggested by Scott Mazur, scott.AT.littlefish.ca)
4. uty/fixrc.pl, a small uty to modify the .openwebmailrc for all users
   (thanks to Scott Mazur, scott.AT.littlefish.ca for his code)


04/24/2003
----------
1. add options header_pluginfile, footer_pluginfile to openwebmail.conf.default
   These options can used to plugin text file or output of other programs
   into most main pages of openwemail.
2. fix a bug that a message in sent folder would be overwritten
   if it was used as a source of draft for another latterly sent message
   (reported by Klaus F. Abel, kfabel.AT.users.sourceforge.net)


04/23/2003
----------
1. fix a bug that ow_htmlutl could not be set to /
   (reported by Gertjan Koetsier, gertjan.koetsier.AT.networksforyou.com)
2. fix a bug that inbox size was not devided by 1024 for unit k
   when compared with spool_limit
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. cut INBOX in cutfoldermails() only if option use_homedirspools is
   set to yes


04/22/2003
----------
1. untaint all argument for exec() to avoid 'Insecure dependency' error
   (reported by dlehoang.AT.users.sourceforge.net)
2. fix to guess_language() to make it works with more languages
   (thanks to Daniel Hasan, dhasan.AT.accesstime.net)
3. output sys error msg ($!) in openwebmailerror()


04/21/2003
----------
1. Serbian language and templates translation update
   fix a bug that the charset for Serbian was not defined in ow-shared.pl
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
2. Portuguese Brazil language and templates translation update
   and holiday file added.
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
3. better compatibility with IE5.5 for filename of attachment in downloading


04/20/2003
----------
1. Ukrainian language and template files translation update
   (thanks to Volodymyr M. Lisivka, lvm.AT.mystery.lviv.net)
2. fix a bug in webdisk that & char in pathname was not properly
   escaped when displayed in showdir
   (reported by tchuang.AT.turtle.ee.ncku.edu.tw)
3. fix a bug that quota_module specified in user conf won't work.
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


04/19/2003
----------
1. simplify API of quota module.
   and switch ruid/euid to root before calling the quota routine
2. Italian language and templates translation update
   (thanks to Marvi Benedet, marvi.AT.menhir.biz)
3. Bulgarian language and template files translation update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)


04/18/2003
----------
1. fix a bug that easter based dates won't show on calendar reminder in msglist
   (reported by Gertjan Koetsier, gertjan.koetsier.AT.networksforyou.com)
2. fix the 'Not privileged' error with quota_unixfs.pl


04/17/2003
----------
1. check redirect destination in vuser editing
   disable 'deletion' of user on vdomain admlist
   (thanks to Littlefish Operator, operator.AT.littlefish.ca for his code)


04/16/2003
----------
1. add option vdomain_mailbox_command to openwebmail.conf.default
   and fix some bug related to virtual user aliases
   vdomain_mailbox_command can be used to pipe mails for virtual users
   to procmail for mail filtering
   (thanks to Littlefish Operator, operator.AT.littlefish.ca for his code)
2. new mirror site at Amsterdam, Netherlands
   http://openwebmail.roel.net/
   (thanks to Roel van der Made, roel.AT.roel.net)
3. disable the encode of german umlaut for in maildb.pl because of
   compatibility problem with languages using double-byte characters
4. remove 'mailto:' from CGI param('to') in openwebmail.pl for IE
   so correct email address can be put in To: field
   when openwebmail is used as default mail client
   (thanks to Sergiy Zubatiy, sergey_sd.AT.users.sourceforge.net)
5. fix a bug in ow-shared.pl which might pass wrong param to timegm()
   This bug is introduced by patch 1 at 04/10/2003
   (reported by Remco Mels, remco.AT.mels.nl)
6. default_language can be set to 'auto' now.
   Openwebmail will guess the default language for login screen and new user
   based on the environment variable HTTP_ACCEPT_LANGUAGE


04/15/2003
----------
1. reimplement the quota system in openwebmail
   a. all modules (webmail, webcal, webdisk) share same set of quota settings.
   b. different quota systems can be used in openwebmail by loading them as
module.
      Two quota modules are available now: quota_unixfix.pl and quota_du.pl
   c. old quota options were removed, including:
      folderquota, folderusage_thresold, cutfolders_ifoverquota, webdisk_quota
   d. new quota options were added, including:
      quota_module, quota_limit, quota_threshold,
      delmail_ifquotahit, delfile_ifquotahit
2. add option enable_history to openwbemail.conf.default
3. add option spool_limit to openwebmail.conf.default
4. encode german umlaut for html in maildb.pl and all de templates
   (thanks to Martin Bronk, Martin.AT.Bronk.de)
5. fix the bug that group address will be lost after addressbook import
   (reported by Niall Walsh, niall.AT.pembrokecricket.com)
6. uty in cgi-bin/openwebmail/uty/addrbook_hotmail2owm.pl,
   which can be used to convert hotmail addressbook to openwebmail
   (thanks to Niall Walsh, niall.AT.pembrokecricket.com for his code)


04/10/2003
----------
1. capture err from timegm() routine to fix the problem that
   some messages with invalid date field may cause CGI internal server error
ps: the bug was introduced by patch 1 at 04/08/2003
2. fix a typo error in ow-shared.pl that gmtim() was used instead of gmtime()
   (reported by Cyril SABATIER, c.sabatier.At.bocquet.com)
ps: the bug was introduced by patch 1 at 04/10/2003


04/09/2003
----------
1. implement is_dst() routine to calc daylight saving time for all timezones.
ps:Since timezone can't be switched through TZ enviro since perl 5.8,
   the is_dst value returned by perl localtime/gmtime is for server timezone only
2. Portuguese Brazil language and templates translation update
   Iconset Cool3D.PortugueseBrazil major update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
3. Deutsch prefs.template update
   (thanks to Martin.Bronk.AT.colt.de)


04/08/2003
----------
1. clean code of timestamp related routines
2. add daylightsaving option (auto/on/off) to user preference to
   fix daylightsaving problem in all timestamps
   (reported by Cyril SABATIER, c.sabatier.At.bocquet.com,
                Remco Mels, remco.AT.mels.nl,
3. fix a bug in message compose window that info of originated message
   won't be passed through iconv() for charset conversion
   (reported by James Briggs, james.AT.ActionMessage.com)
4. fix a bug in openwebmail.pl that newly created domainhome would have
   wrong permission which prevents the following access to user homedir.
   (reported by Aboobacker Valappil, aboo.AT.aboosplanet.com)
5. if the msg transmission time is longer than 7 days or smaller than -1 day
   we assume sender host may have wrong time confiuration and
   use delivery time instead of sending time as message timestamp


04/05/2003
----------
1. add new button "forard as original" button to compose message window
   (thanks to Dattola Filippo, filippo.AT.sms.it for his patch)
ps:Please refer to faq for the difference between forward, forwardasatt
   and forwardasorig


04/04/2003
----------
1. fix typo error in auth_pam.pl which caused changepwd failed
   (reported by Louie Ching, fitman.AT.users.sourceforge.net)
2. show 'please wait' while doing uploading in webdisk
3. fix a bad behavior introduced by patch 2 04/03/2003
   which tried to always use http for images
   (reported by Martin Gignac, lmcgign.AT.mobilitylab.net)
4. French help tutorial translation
   (thanks to Frederic GLISE, fred.AT.forceinfo.net)


04/03/2003
----------
1. fix a typo error in error msg in auth_vdomain.pl
2. add a new option forced_ssl_login to openwebmail.conf.default
3. fix a bug in openwebmail-send.pl that cause old msg saved-drafts
   not being deleted. It was due to the use of LOCK_EX before a readonly
   dbmopen, which caused the "Resource temporarily unavailable" error
   in dbmopen if underlying dbm system is GDBM.
   (reported by Meesha, HyperTGP.com, meesha.AT.hypertgp.com)


04/02/2003
----------
1. Serbian language translation minor update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)


04/01/2003
----------
1. use time()-1 for timestamp of session file, .pop3.check and .trash.check
   to ensure nfs client time won't be replaced on nfs server side
2. code clean to synchronize the format of logged messages
3. put logindomain param back to login page when user logout or login failure
   (thanks to Scott Mazur, scott.AT.littlefish.ca for his fix)
4. fix openwebmail-send.pl
   a. log the success or failure of mail sending
   b. timeout=20 if only one recipient for quicker response.
      timeout=90 for more than one recipients,
      so dns timeouted reciptents could be skipped properly
      (DNS timeout default=60)
5. fix a bug that attachment uploaded to message could not be viewed
   this bug was introduced by patch 2 at 03/31/2003
   (reported by tchuang.AT.turtle.ee.ncku.edu.tw)


03/31/2003
----------
1. test whether option has_savedsuid_support is required to be set
   in openwebmail-tool.pl --init
2. extend the session time by updating timestamp of session file
   instead of rewriting th whole file, minor speed improvement.


03/29/2003
----------
1. Urdu language and templates translation
   (thanks to Muhammad Umair Abbasi, umair.AT.khi.wol.net.pk)
2. easter day support in calendar
   (thanks to Dugal James P., jpd.AT.louisiana.edu for his patch)
3. new option ow_holidaysdir to define the directory for holiday files


03/27/2003
----------
1. clean init code in all openwebmail*pl
2. fix a bug in auth_unix*.pl and auth_pam*.pl that
   get_userinfo() won't success if passwd is from a command pipe
   eg: "/usr/bin/ypcat passwd|"
   (reported by Dugal James P., jpd.AT.louisiana.edu)
3. support to list packages used by perl dbm system
   in openwebmail-tool.pl (with --test option) and dbmtest.pl
4. fix a bug in auth_unix.pl and auth_unix_cobalt.pl that
   change_userpassword always return -3.
   This is due to the child process exit value was taken by SIG CHLD handler,
   so system() always get error even command is actually done successfully.


03/26/2003
----------
1. Hebrew language and templates translation
   (thanks to Yehuda Drori, yehuda.AT.whatsup.org.il)
2. chmod of /etc/virtusertable dbm to 644 so it can be read in user uid
3. fix a bug that -a option of openwebmail-tool.pl doesn't work
   (reported by Pawel Jablonski, pawelj.AT.lodz.dialog.net.pl)
4. skip lines with leading # when getting user list from passwd file


Below are brief descriptions for versions before 2.00.
To get more detail, please refer to changes.txt in version 2.00

03/25/2003 (version 2.00)	speedycgi support
02/12/2003 (version 1.90)	webdisk support support
11/22/2002 (version 1.80)	iconv support
07/12/2002 (version 1.70)	calendar support
01/24/2002 (version 1.60)	send mail though SMTP server
10/31/2001 (version 1.50)	introduce pure text openwebmail.conf
08/16/2001 (version 1.40)	split authentication into modules
06/18/2001 (version 1.30)	support sendmail virtual user, autoreply
06/07/2001 (version 1.20)	support spell checking
04/26/2001 (version 1.10)	support save draft, confirm reading
03/02/2001 (version 1.00)	support pop3, mailfilter
				support uuencoded attachment
				support html message display
				support message search
				speedup access with dbm
09/14/2000 (neomail 1.14)	first test drive

